/*
 * ProjectBuilder.java
 * June 1998, Jean-Marc Koller
 */

package KheperaTerminal;

import java.lang.Runtime;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.Icon;
import javax.swing.border.TitledBorder;
import javax.swing.border.LineBorder;
import javax.swing.Box;
import javax.swing.BoxLayout;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.FileDialog;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowListener;

public class ProjectBuilder implements WindowListener, ActionListener
{
  JFrame frame;
  JPanel panel, but_panel;
  JButton but_create;
  String architectures[] =
  {"Khepera", "Koala"};
  JComboBox combo;
  Icon image;

  public void windowClosed (WindowEvent e)
  {
  }
  public void windowDeiconified (WindowEvent e)
  {
  }
  public void windowIconified (WindowEvent e)
  {
  }
  public void windowActivated (WindowEvent e)
  {
  }
  public void windowDeactivated (WindowEvent e)
  {
  }
  public void windowOpened (WindowEvent e)
  {
  }
  public void windowClosing (WindowEvent e)
  {
    System.exit (0);
  }

  /* Copy files from source to destination */
  static final int BUFSIZE = 16 * 1024;
  public boolean copyFile (String src, String dst)
  {
    FileInputStream fi;
    FileOutputStream fo;
      try
    {
      fi = new FileInputStream (src);
    }
    catch (FileNotFoundException fnfe)
    {
      System.out.println ("file " + src + " not found!");
      return true;
    }
    try
    {
      fo = new FileOutputStream (dst);
    }
    catch (IOException ioe)
    {
      try
      {
	fi.close ();
      }
      catch (IOException ioe2)
      {
      }
      System.out.println ("Unable to open " + dst + " for writing!");
      return true;
    }
    byte[]buffer = new byte[BUFSIZE];
    try
    {
      while (fi.available () > 0)
	fo.write (buffer, 0, fi.read (buffer));
    }
    catch (IOException ioe)
    {
      System.out.println ("Error during copy of files...");
      try
      {
	fi.close ();
	fo.close ();
      }
      catch (IOException ioe2)
      {
      }
      return true;
    }
    try
    {
      fi.close ();
      fo.close ();
    }
    catch (IOException ioe)
    {
    }
    return false;
  }

  /* Create a directory */
  public boolean mkdir (String folder)
  {
    String comline = "mkdir " + folder;
      try
    {
      Runtime.getRuntime ().exec (comline).waitFor ();
    }
    catch (IOException ioe)
    {
      System.out.println ("ioe=" + ioe);
      return true;
    }
    catch (InterruptedException ie)
    {
      return true;
    }
    return false;
  }

  /* listener for buttons */
  public void actionPerformed (ActionEvent e)
  {
    String action = e.getActionCommand ();
    if (action.equals ("Create project"))
      {
	FileDialog fd = new FileDialog (frame, "Give a foldername", FileDialog.SAVE);
	  fd.show ();
	if (fd.getFile () != null && fd.getFile ().length () > 0)
	  {
	    String dstfolder = fd.getDirectory () + fd.getFile ();
	    if (mkdir (dstfolder))
	        return;
	    if (copyFile ("makefile." + combo.getSelectedItem (), dstfolder + "/makefile"))
	        return;
	    if (copyFile ("template.dcp", dstfolder + "/" + fd.getFile () + ".dcp"))
	        return;
	    if (copyFile ("template.ses", dstfolder + "/" + fd.getFile () + ".ses"))
	        return;
	    if (copyFile ("main.c", dstfolder + "/main.c"))
	        return;
	      System.out.println ("Creation of project completed!");
	  }
	return;
      }
    System.out.println ("action=" + e);
  }

  /* constructor */
  public ProjectBuilder ()
  {
    frame = new JFrame ("KheperaTools project builder");
    frame.addWindowListener (this);

    combo = new JComboBox ();
    for (int i = 0; i < architectures.length; i++)
      combo.addItem (architectures[i]);
    combo.setEditable (false);
    combo.setMaximumRowCount (6);
    Dimension cdim = combo.getMinimumSize ();
      cdim.width += 100;
      combo.setMinimumSize (cdim);

      but_create = new JButton ("Create project");
      but_create.addActionListener (this);

      panel = new JPanel ();
      panel.setLayout (new BoxLayout (panel, BoxLayout.Y_AXIS));
    JPanel cpanel = new JPanel ();
    //cpanel.setBorder( new TitledBorder( LineBorder.createGrayLineBorder(), "Target architecture" ) );
    JLabel label = new JLabel ("Target architecture for project:");
      cpanel.add (label);
      cpanel.add (Box.createRigidArea (new Dimension (5, 0)));
      cpanel.add (combo);
      panel.add (cpanel);
    JPanel bpanel = new JPanel ();
      bpanel.add (but_create);
      panel.add (bpanel);
      frame.getContentPane ().add (panel);

      frame.pack ();
    Dimension screenSize = Toolkit.getDefaultToolkit ().getScreenSize ();
    Dimension frameSize = frame.getSize ();
      frame.setLocation (screenSize.width / 2 - frameSize.width / 2, screenSize.height / 2 - frameSize.height / 2);
      frame.show ();
  }

  public static void main (String argv[])
  {
    new ProjectBuilder ();
  }
};
