/*
 * Xscale.java
 * June 1998, Jean-Marc Koller
 */

/* Horizontal gaduation as analyzer. */

package KheperaTerminal;

import javax.swing.JPanel;
import java.awt.Dimension;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Rectangle;
import java.io.FileOutputStream;
import java.io.IOException;

public class Xscale extends Component implements Analyzer
{
  int mintime, maxtime;
  int zoomT;

  public Xscale ()
  {
    mintime = 0;
    maxtime = 0;
    zoomT = 1;
  }

  public void setTime (int mint, int maxt)
  {
    mintime = mint;
    maxtime = maxt;
  }

  public int addData (int timestamp, byte[]buffer, int offset)
  {
    return 0;
  }

  public int exportData (FileOutputStream fo, byte[]buffer, int offset) throws IOException
  {
    return 0;
  }

  public int DataSize ()
  {
    return 0;
  }

  public Component getComponent ()
  {
    return this;
  }

  public void addComponent (JPanel panel)
  {
    panel.add (this);
  }

  public String getName ()
  {
    return "X scale";
  }

  public void incSize ()
  {
  }

  public void setZoomTime (int factor)
  {
    zoomT = factor;
  }

  public void setZoomValue (int factor)
  {
  }

  public Dimension getMinimumSize ()
  {
    return new Dimension ((maxtime - mintime) / zoomT, 40);
  }

  public Dimension getPreferredSize ()
  {
    return getMinimumSize ();
  }

  public void paint (Graphics g)
  {
    int dect = (((mintime + 9) / 10) * 10) - mintime;
    int x = dect;
    int t = mintime + dect;
    for (; t < maxtime; t += 10 * zoomT, x += 10)
      {
	int dx = 5;
	if ((t % 50 * zoomT) == 0)
	    dx = 10;
	if ((t % 100 * zoomT) == 0)
	    dx = 15;
	  g.setColor (Color.darkGray);
	  g.drawLine (x, 0, x, dx);
	if ((t % 100 * zoomT) == 0)
	    g.drawString ("" + t, x - 5, 30);
      }

  }

};
